/*
**********************************************************************
*                        License Notice
*
* QPlyPosition.java is part of the Quincala Software Project, which is
* aimed at playing, viewing, studying, communicating and publishing
* games; primarily the Quincala games, but in time any game that fits.
*
* (C) Copyright 2010 Ulf Aberg (Åberg) and AB Games Ltd. All Rights
* Reserved.
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
* Here is also a copy of the gpl licence version 3 in html format,
* called "gpl-3.0-standalone.html" in the com.quincala.core/docs folder.
*
* This licence does not provide any license or right to use any
* trademark owned by Ulf Aberg (Åberg) or AB Games Ltd in any form or
* media. QUINCALA is a registered trademark owned by Ulf Aberg (Åberg).
*
* The design of the (classic) Quincala board is a Registered Design,
* also owned by Ulf Aberg (Åberg).
*
* Contact Ulf on ulf@quincala.com
*
**********************************************************************
*/


package com.quincala.core;

public class QPlyPosition {

	/*
	 * This holds essentially a pure ply string and the brake value
	 * (whether or not to perform releasing after the last ply)
	 * It will also have methods for converting the strings to
	 * loc arrays as well as to hashes
	 * It might extend QLocPosition if converting char to int is common
	 */

	public String purePlyString = "";
	public boolean zeroplyBrake = true;
	public int plyPosInt = 0;

	/*
	 * default brake is true, since
	 * 1. wish to have a custom startposition before releasing:
	 * load startposition & plyString
	 * 2. wish to have a custom startposition after releasing:
	 * load startposition as after releasing & default QPlyPosition
	 * (no possibility to retrace releasing:)
	 * 3. 2) but with retrace:
	 * load startposition & plyString with x in front! (=brake false)
	 */






	public void setPurePlyString(String purePlyString) {
		this.purePlyString = purePlyString;
		this.plyPosInt = purePlyString.length();
	}
	public void setZeroplyBrake(boolean zeroplyBrake) {
		this.zeroplyBrake = zeroplyBrake;
	}

	//not in order yet!
//	public void makeIncremental(int startPlyPos){
//		purePlyString = purePlyString.substring(startPlyPos,plyPosInt);
//	}

//	public void setPlyPosInt(int plyPosInt) {
//		this.plyPosInt = plyPosInt;
//	}

}
